﻿Imports Infragistics.Win
Imports Infragistics.Win.UltraWinSchedule
Imports Infragistics.Win.UltraWinEditors
Imports Infragistics.Win.UltraWinSchedule.MonthViewSingle

Class CreationFilter
    Implements IUIElementCreationFilter

    Dim textElementHeight As Integer = -1

    Public Sub AfterCreateChildElements(parent As UIElement) Implements IUIElementCreationFilter.AfterCreateChildElements
        Dim textElement As TextUIElement = TryCast(parent, TextUIElement)
        If textElement IsNot Nothing Then
            Dim noteElement As NoteUIElement = textElement.GetAncestor(GetType(NoteUIElement))

            If Me.textElementHeight = -1 Then
                textElementHeight = textElement.Rect.Height
            End If

            If noteElement IsNot Nothing Then
                Dim size As SizeF
                Using g As Graphics = textElement.Control.CreateGraphics()
                    size = g.MeasureString(textElement.Text, textElement.Control.Font)
                End Using

                If noteElement.Rect.Width > 0 Then
                    Dim note As Note = noteElement.Note

                    Dim dayElement As DayUIElement = noteElement.Parent.GetDescendant(GetType(DayUIElement), note.Day)
                    Dim textRows As Integer = CInt(Math.Ceiling(size.Width)) / noteElement.Rect.Width

                    If noteElement.Rect.Height < textElementHeight * textRows Then
                        Dim noteElementHeight As Integer = noteElement.Rect.Height * textRows
                        If noteElement.Rect.Y + noteElementHeight > dayElement.Rect.Bottom Then
                            noteElementHeight = dayElement.Rect.Bottom - noteElement.Rect.Y
                        End If

                        noteElement.Rect = New Rectangle(noteElement.Rect.X, noteElement.Rect.Y, noteElement.Rect.Width, noteElementHeight)
                    End If

                    textElement.Rect = noteElement.Rect
                    textElement.WrapText = True
                End If
            End If
        End If
    End Sub

    Public Function BeforeCreateChildElements(parent As UIElement) As Boolean Implements IUIElementCreationFilter.BeforeCreateChildElements

        Return False
    End Function
End Class
